darcs-2.8.4: a distributed, interactive, smart revision control system

Portability | portable
Stability | experimental
Maintainer | darcs-devel@darcs.net
Safe Haskell | Safe-Infered

English

Description

This modules provides rudimentary natural language generation (NLG) utilities. That is, generating natural language from a machine representation. Initially, only English is supported at all. Representations are implemented for:

- countable nouns (plurality); and * lists of clauses (foo, bar and/or baz).

Synopsis

- englishNum :: Countable n => Int -> n -> ShowS
- class Countable a where
  - plural :: a -> ShowS
  - singular :: a -> ShowS
- newtype Noun = Noun String
- data Pronoun = It
- data This = This Noun
- andClauses :: [String] -> String
- orClauses :: [String] -> String
- intersperseLast :: String -> String -> [String] -> String
- presentParticiple :: String -> String

# Documentation

englishNum :: Countable n => Int -> n -> ShowS

     englishNum 0 (Noun "watch") "" == "watches"
     englishNum 1 (Noun "watch") "" == "watch"
     englishNum 2 (Noun "watch") "" == "watches"

class Countable a where

Things that have a plural and singular spelling

Methods

plural :: a -> ShowS

singular :: a -> ShowS

Instances

Countable This |
Countable Pronoun |
Countable Noun |

newtype Noun

This only distinguishes between nouns with a final -ch, and nouns which do not. More irregular nouns will just need to have their own type

     plural (Noun "batch") "" == "batches"
     plural (Noun "bat")   "" == "bats"
     plural (Noun "mouse") "" == "mouses" -- :-(

Constructors

Noun String |

Instances

Countable Noun |

data Pronoun

Constructors

It |

Instances

Countable Pronoun |

data This

     singular This (Noun "batch") "" == "this batch"
     plural   This (Noun "batch") "" == "these batches"

Constructors

This Noun |

Instances

Countable This |

andClauses :: [String] -> String

Given a list of things, combine them thusly:

     orClauses ["foo", "bar", "baz"] == "foo, bar or baz"

orClauses :: [String] -> String

Given a list of things, combine them thusly:

     orClauses ["foo", "bar", "baz"] == "foo, bar or baz"

intersperseLast :: String -> String -> [String] -> String

As `intersperse`, with a different separator for the last | interspersal.

presentParticiple :: String -> String